// CSE165 Tetris block project starter code
// @author Matteo Mannino 
// @email mtmannin@eng.ucsd.edu

#include<Windows.h>
#include<iostream>
#include<vector>
#include<stdlib.h>
#include<time.h>

#include <osgViewer/Viewer>

#include <osgViewer/ViewerEventHandlers>
//#include <osgGA/StateSetManipulator>
#include <osg/Node>
#include <osg/Group>
#include <osg/Geode>
#include <osg/ShapeDrawable>
#include <osg/MatrixTransform>
#include <osg/PositionAttitudeTransform>
#include <osgDB/ReadFile>
#include <osgGA/TrackballManipulator>
#include <osg/Material>
#include <osg/StateSet>
#include <osg/Projection>
#include <osg/NodeVisitor>
#include <osg/CameraNode>
#include <osgGA/NodeTrackerManipulator>
#include <osg/Timer>

#include "TetrisBlock.h"

using namespace std;
using namespace osg;

// if on linux, use the actual drand48
double drand48()
{
	return ((double)rand())/RAND_MAX;
}

int main()
{
	srand(time(NULL));
	//Creating the viewer	
    osg::ref_ptr<osgViewer::Viewer> viewer(new osgViewer::Viewer);
	
	// Window size. Comment this out if you want full screen.
	viewer->setUpViewInWindow(100,100,800,800);
	
	//Creating the root node
	osg::ref_ptr<osg::Group> root (new osg::Group);

	// piece demo
	//TetrisBlock tblock[8];
	//for(int i = 0; i < 8; ++i) {
	//	tblock[i].set(i, Vec3d(5*i,0,0), 0,0,0);
	//	tblock[i].attachToGroup(root);
	//};

	// build scene
	double theta = 0.0f;
	double phi = 0.0f;
	const int numblocks_theta = 4;
	const int numblocks_phi = 4;
	const int numblocks = numblocks_theta*numblocks_phi;
	const double rad = 8;
	TetrisBlock tblock[numblocks];
	for(int i = 0; i < numblocks_theta; ++i) {
		for(int j = 0; j < numblocks_phi; ++j) {
			theta = osg::PI*((double)(i+1))/(numblocks_theta+1);
			phi = 2.0*osg::PI*((double)j)/numblocks_phi;
			tblock[i].set(rand()%8, Vec3d(rad*sin(theta)*cos(phi), rad*sin(theta)*sin(phi), rad*cos(theta)), rand()%4, rand()%4, rand()%4);
			tblock[i].attachToGroup(root);
		}
	};

	// set root node to viewer
	viewer->setSceneData( root.get() ); 

	// Windows size handler
	viewer->addEventHandler(new osgViewer::WindowSizeHandler);

	// set camera manipulation to a trackball
	viewer->setCameraManipulator(new osgGA::TrackballManipulator());
	
	// The main loop
	viewer->realize();
	while(!viewer->done()) {

		// TODO
		// 1. do hydra stuff, when block moves save the previous position

		// TODO
		// Implement collision detection in TetrisBlock.h/cpp

		// TODO
		//every time you move a tetris block, you want to check if it collides with any others
		//int movedblock = The moved block
		//for(int i = 0; i < numblocks; ++i) {
		//	if(i != movedblock && tblock[movedblock].collidesWith(tblock[i])) {
		//		Return block back to previous position
		//		break;
		//	}
		//}

		// TODO
		// Compute bounding cube using getGlobalAtomPositions (that you've implemented)
		// and saving the min and max of each axis. Then take the max distance on each axis to
		// define the bounding cube. The bounding volume is then max_dist^3

		// TODO

		// TODO
		// BE AWESOME (and whatever the project page says)

		viewer->frame(); // render frame
	}
	
	return 0;
}